# Useful constants
# copyright skaapsteker team (see COPYRIGHT file for details)

import pygame

SCREEN = (800, 600)
FREQ = 44100   # same as audio CD
BITSIZE = -16  # unsigned 16 bit
CHANNELS = 2   # 1 == mono, 2 == stereo
BUFFER = 1024  # audio buffer size in no. of samples

DEBUG = True

EPSILON = 1e-10

# Time parameter for double key taps checked.
# This is for both key down time and for gap between taps
DOUBLE_TAP_TIME = 0.15


# Layer defination
class Layers(object):
    SKAAPSTEKER = -1 # Special layer for snakes
    BACKGROUND = 0  # Absolute background
    BEHIND = 1  # Layer behind the player
    PLAYER = 2  # Layer of the player and enemies
    IN_FRONT = 3 # Layer in front of the player
    FOREGROUND = 4  # Absolute foreground


class FoxHud(object):
    TEXT = pygame.Color(255, 255, 255, 196)

    BG_ALPHA = 120
    BG_MARGIN = 8

    INVENTORY_SIZE = 48
    INVENTORY_START = 32

    TAIL_START = 100
    TAIL_OFFSET = 50
    TAIL_POSITIONS = {
            'shapeshift' : TAIL_START,
            'fireball' : TAIL_START + TAIL_OFFSET,
            'sprint' : TAIL_START + 2 * TAIL_OFFSET,
            'invisibility' : TAIL_START + 3 * TAIL_OFFSET,
            'flight' : TAIL_START + 4 * TAIL_OFFSET,
            'shield' : TAIL_START + 5 * TAIL_OFFSET,
            'steal' : TAIL_START + 6 * TAIL_OFFSET,
            'lightning' : TAIL_START + 7 * TAIL_OFFSET,
            }
    TAILS_BG_MARGIN = 2
    TAILS_WIDTH = 42
    TAILS_HEIGHT = 8 * TAIL_OFFSET

    HEALTH_BACKGROUND = pygame.Color(128, 64, 0, 128)
    HEALTH_FOREGROUND = pygame.Color(255, 64, 0, 196)
    HEALTH_HEIGHT = 160
    HEALTH_WIDTH = 20

    SCROLL_TOP = 220
    TOFU_TOP = 280
